package com.xiaoliu.handler;

import com.xiaoliu.codec.Codec;
import com.xiaoliu.protocol.FilePacket;
import io.netty.buffer.ByteBuf;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.handler.stream.ChunkedFile;
import lombok.extern.slf4j.Slf4j;

import java.io.File;

@Slf4j
public class MyClientHandler extends ChannelInboundHandlerAdapter {

	@Override
	public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
		log.info("msg : {}", msg.toString());
		ByteBuf byteBuf = (ByteBuf) msg;
		FilePacket filePacket = (FilePacket) Codec.INSTANCE.decode(byteBuf);
		File file = filePacket.getFile();
        log.info("prepared send: {}", file.getName());

		Channel channel = ctx.channel();
		channel.writeAndFlush(new ChunkedFile(filePacket.getFile()));
		// channel.writeAndFlush(new DefaultFileRegion(file, 0, file.length()));

	}
}
