package com.xiaoliu.console;

import com.xiaoliu.console.impl.SendFileConsole;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

@Slf4j
public class ConsoleManager implements Console {

	private Map<String, Console> consoleMap;

	public ConsoleManager() {
		consoleMap = new HashMap<>();
		consoleMap.put("sendFile", new SendFileConsole());
	}

	@Override
	public void exec(Channel channel, Scanner scanner) {
		String consoleType = scanner.nextLine();
		Console console = consoleMap.get(consoleType);
		if (console != null) {
			console.exec(channel, scanner);
		} else {
            log.info("无法识别指令：{}", consoleType);
		}

	}

}
