package com.xiaoliu.console.impl;

import com.xiaoliu.console.Console;
import com.xiaoliu.protocol.FilePacket;
import com.xiaoliu.util.SessionUtil;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.util.Map;
import java.util.Scanner;

@Slf4j
public class SendFileConsole implements Console {
	@Override
	public void exec(Channel channel, Scanner scanner) {
		log.info("请输入文件路径：");
		String path = scanner.nextLine();

		File file = new File(path);
		FilePacket filePacket = new FilePacket(file);

		Map<String, Channel> channelMap = SessionUtil.getNodeIdChannelMap();
		for (Map.Entry<String, Channel> entry : channelMap.entrySet()) {
			entry.getValue().writeAndFlush(filePacket);
		}
	}
}
